#include	"modex.h"
#include	<dos.h>

void XInit()
{
 union REGS	in, out;

 /* Call BIOS for mode 0x13 */

 in.x.ax	= 0x13;
 int86(0x10, &in,	&out);

 /* Unchain */

 outportw(0x3c4, 0x0604);
 outportw(0x3d4, 0xe317);
 outportw(0x3d4, 0x0014);
}

void XText()
{
 union REGS	in, out;

 in.x.ax	= 0x3;
 int86(0x10, &in,	&out);
}

void XPlot(int	x,	int y, char	c)
{
 outportb(0x3c4, 0x2);
 outportb(0x3c5, 1 << (x &	3));
 dosmemput(&c,	1,	(X_BYTES	* y) + (x / 4)	+ VIDEO_MEM);
}

int main()
{
 int x, y;

 XInit();

 for (x = 0; x	< 256; x++)	{
  for	(y	= 0; y <	200; y++) XPlot(x, y, x);
 }

 for (x=0; x<197 ; x++)	XPlot(x,256-x,0x23);
 for (x=1; x<198 ; x++)	XPlot(x,255-x,0x24);
 for (x=2; x<199 ; x++)	XPlot(x,254-x,0x25);
 for (x=3; x<200 ; x++)	XPlot(x,253-x,0x26);

 for (x=0; x<200 ; x++)	XPlot(x,x,0x26);
 for (x=1; x<199 ; x++)	XPlot(x+1,x,0x25);
 for (x=2; x<198 ; x++)	XPlot(x+2,x,0x24);
 for (x=3; x<197 ; x++)	XPlot(x+3,x,0x23);
 while (!kbhit());
 getkey();

 XText();
 return(0);
}
  

